src/Entity/User.php
<?php

namespace App\Entity;

use App\Repository\UserRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\HttpFoundation\File\File;
use Vich\UploaderBundle\Mapping\Annotation as Vich;


/**
 * @ORM\Entity(repositoryClass=UserRepository::class)
 *  @UniqueEntity(
 * fields = {"email"},
 * message ="l'email que vous avez indiqué est deja utilisé !")
 *  @Vich\Uploadable
 */
class User implements UserInterface
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")     
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $username;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $email;

     /**
     * @ORM\Column(type="json")
     */
    private $roles = [];

    /**
     * @ORM\Column(type="string", length=255)
     *  @Assert\Length(min="8", minMessage="Votre mot de passe doit faire minimum 8 caractère") 
     */
    private $password;

     /**
    * @Assert\EqualTo(propertyPath="password", message="Vous n'avez pas tapé le même mot de passe")
     */

    public $Confirm_Password;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $address;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $phone;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $city;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $postal_code;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $firstname;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $lastname;

    /**
     * @ORM\OneToMany(targetEntity=Borrowing::class, mappedBy="Borrowing")
     */
    private $Borrowing;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $Genres;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $subscription;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $subscriptionstatus;

  

   

  

   

    public function __construct()
    {
        $this->Borrowing = new ArrayCollection();
    }

    // ... other fields

   
    public function getId(): ?int
    {
        return $this->id;
    }

    public function getUsername(): ?string
    {
        return $this->username;
    }

    public function setUsername(string $username): self
    {
        $this->username = $username;

        return $this;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    public function getPassword(): ?string
    {
        return $this->password;
    }

    public function setPassword(string $password): self
    {
        $this->password = $password;

        return $this;
    }
    public function eraseCredentials() {}

    public function getSalt() {}

    public function getRoles(): ?array
    {
        $roles = $this->roles;  
        //guarantee every user at least has ROLE_USER      
        $roles[] = 'ROLE_USER';
        
        return array_unique($roles);
    }

    public function setRoles(array $roles): self
    {
        $this->roles = $roles;

        return $this;
    }

    public function getAddress(): ?string
    {
        return $this->address;
    }

    public function setAddress(string $address): self
    {
        $this->address = $address;

        return $this;
    }

    public function getPhone(): ?string
    {
        return $this->phone;
    }

    public function setPhone(string $phone): self
    {
        $this->phone = $phone;

        return $this;
    }

    public function getCity(): ?string
    {
        return $this->city;
    }

    public function setCity(string $city): self
    {
        $this->city = $city;

        return $this;
    }

    public function getPostalCode(): ?string
    {
        return $this->postal_code;
    }

    public function setPostalCode(string $postal_code): self
    {
        $this->postal_code = $postal_code;

        return $this;
    }

    public function getFirstname(): ?string
    {
        return $this->firstname;
    }

    public function setFirstname(string $firstname): self
    {
        $this->firstname = $firstname;

        return $this;
    }

    public function getLastname(): ?string
    {
        return $this->lastname;
    }

    public function setLastname(string $lastname): self
    {
        $this->lastname = $lastname;

        return $this;
    }

    /**
     * @return Collection|Borrowing[]
     */
    public function getBorrowing(): Collection
    {
        return $this->Borrowing;
    }

    public function addBorrowing(Borrowing $borrowing): self
    {
        if (!$this->Borrowing->contains($borrowing)) {
            $this->Borrowing[] = $borrowing;
            $borrowing->setPurchase($this);
        }

        return $this;
    }

    public function removeBorrowing(Borrowing $borrowing): self
    {
        if ($this->Borrowing->contains($borrowing)) {
            $this->Borrowing->removeElement($borrowing);
            // set the owning side to null (unless already changed)
            if ($borrowing->getPurchase() === $this) {
                $borrowing->setPurchase(null);
            }
        }

        return $this;
    }

    public function getGenres(): ?string
    {
        return $this->Genres;
    }

    public function setGenres(string $Genres): self
    {
        $this->Genres = $Genres;

        return $this;
    }

    public function getSubscription(): ?string
    {
        return $this->subscription;
    }

    public function setSubscription(string $subscription): self
    {
        $this->subscription = $subscription;

        return $this;
    }

    public function getSubscriptionstatus(): ?string
    {
        return $this->subscriptionstatus;
    }

    public function setSubscriptionstatus(string $subscriptionstatus): self
    {
        $this->subscriptionstatus = $subscriptionstatus;

        return $this;
    }
    public function __toString()
    {
        return $this->username;
    }

   

   
   

  
}

src/Form/PersoType.php
<?php

namespace App\Form;

use App\Entity\User;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;

class PersoType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('genres',ChoiceType::class,array(
            'choices'  => array(
                'Monsieur' => 'Monsieur',
                'Madame' => 'Madame',                    
            ),
            'expanded' => true,
            'multiple' => false
        )) 
            
            ->add('email')   
            ->add('address')
            ->add('phone')
            ->add('city')
            ->add('postal_code')
            ->add('firstname')
            ->add('lastname') 
            ->add('subscription',ChoiceType::class,array(
                'choices'  => array(
                    'Mensuel (3€)' => 'Mensuel',
                    'Annuel (15€)' => 'Anneul',                    
                ),
                'expanded' => true,
                'multiple' => false
            ))  
            ->add('subscriptionstatus',ChoiceType::class,array(
                'choices'  => array(
                    'En Attente' => 'En Attente',
                    'Validée' => 'Validée',                    
                ),
                'expanded' => true,
                'multiple' => false
            ))              
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => User::class,
        ]);
    }
}

src/Controller/CustomerController.php
<?php

namespace App\Controller;

use DateTime;
use App\Entity\User;
use App\Entity\Vinyle;
use App\Entity\Borrowing;
use App\Form\PersoCustType;
use App\Form\SearchVinyleType;
use App\Form\Borrowing_ReturnType;
use App\Repository\UserRepository;
use App\Repository\VinyleRepository;
use App\Repository\BorrowingRepository;
use Knp\Component\Pager\PaginatorInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;




/**
   * @Route("/customer")
   */

class CustomerController extends AbstractController
{
    /*Index Customer*/

    /**
     * @Route("/", name="dashboard_index_customer")
     */

    public function index_dashboard_customer(UserRepository $userRepository){
        return $this->render('Customer/dashboard.index.html.twig',[
            'users' => $userRepository->findAll(),
        ]);
    }

    /**
     * @Route("/catalogue", name="catalogue_resa")
     */

    public function index(Request $request,VinyleRepository $vinyleRepository, PaginatorInterface $paginator)
    {
        $donnees = $this->getDoctrine()->getRepository(Vinyle::class)->findAll();
        $vinyle = $paginator->paginate(
            $donnees, // Requête contenant les données à paginer (ici nos articles)
            $request->query->getInt('page', 1), // Numéro de la page en cours, passé dans l'URL, 1 si aucune page
            5 // Nombre de résultats par page
        );

        $vinyles=[];
        $form = $this->createForm(SearchVinyleType::class);

        $search=$form->handleRequest($request);

        if($form->isSubmitted() && $form->isValid()){
            // ici on recherche les vinyles correspondant aux mots clés
            $vinyles= $vinyleRepository->search(
                $search->get('mots')->getData(),
                $search->get('interpreter')->getData(),
                $search->get('vinyle_genre')->getData());

        }
        return $this->render('Customer/Catalogue/Reservation.html.twig', [
            'vinyles' => $vinyles,
            'form'=>$form->createView(),
            'vinyle'=>$vinyle

        ]);
    }


    /**
     * @Route("/catalogue/{id}", name="catalogue_show", methods={"GET"})
     */

    public function show_catalogue(Vinyle $vinyle): Response
    {
        return $this->render('Customer/Catalogue/show.html.twig', [
            'vinyle' => $vinyle,
        ]);
    }

    /**
     * @Route("/{id}/{user}/select", name="vinyle_selection", methods={"GET","POST"})
     */
    public function vinyle_selection($id,$user)
    {
        $entityManager = $this->getDoctrine()->getManager();
        $vinyle = $entityManager->getRepository(Vinyle::class)->find($id);
        if (!$vinyle) {
            throw $this->createNotFoundException(
                'No vinyle found for id '.$id
        );
        }

        $vinyle->setAvaibility(false);
        if($this->getUser())
        {
            $username = $this->getUser()->getUsername();
            $vinyle->setBorrower($username);
        }
        else{
            return $this->redirectToRoute('security_login');
        }

        $entityManager->flush();
        return $this->redirectToRoute('basket_show', [
        'id' => $vinyle->getId()
    ]);
}

    /**
     * @Route("/{id}/deselect", name="vinyle_deselection", methods={"GET","POST"})
     */

    public function vinyle_deselection($id)
    {
        $entityManager = $this->getDoctrine()->getManager();
        $vinyle = $entityManager->getRepository(Vinyle::class)->find($id);
        if (!$vinyle) {
            throw $this->createNotFoundException(
                'No vinyle found for id '.$id
        );
        }

        $vinyle->setAvaibility(true);
        $vinyle->setBorrower("");
        $entityManager->flush();
        return $this->redirectToRoute('catalogue_resa', [
        'id' => $vinyle->getId()
    ]);
    }

    /**
     * @Route("/basket/show", name="basket_show", methods={"GET"})
     */

    public function show_basket(VinyleRepository $vinyleRepository): Response
    {
        if($this->getUser())
        {
        $username = $this->getUser()->getUsername();
        }
        return $this->render('Customer/basket/index.html.twig', [
            'vinyles' => $vinyleRepository->findByBorrower($username),
        ]);
    }

    /**
     * @Route("/basket/validate", name="basket_validate", methods={"GET","POST"})
     */

    public function validate_basket(VinyleRepository $vinyleRepository)
    {
        if($this->getUser())
        {
            $username = $this->getUser()->getUsername();
        }
        $currentdate=new \DateTime();
        $ref=$currentdate->format('YmdHi');
        return $this->creation_borrowing($username,$ref,$vinyleRepository);

    }

    /**
     * @Route("/{ref}/{borrower}/generate", name="borrowing_creation", methods={"GET","POST"})
     */

    public function creation_borrowing($borrower ,$ref,VinyleRepository $vinyleRepository )
    {
        $em = $this->getDoctrine()->getManager();
        $borrowing = new Borrowing();
        $username = $this->getUser()->getUsername();
        $borrowing->setBorrower($username);
        $borrowing->setRef($ref);
        $borrowing->setStartDate(new \DateTime('now'));
        $borrowing->setEndDate(new DateTime('+1 month'));
        $borrowing->setCreatedAt(new \DateTime('now'));
        $borrowing->setRefsent('none');
        $borrowing->setRefback('none');
        $borrowing->setBorrowingstatus('Soumise');

        $em->persist($borrowing);
        $em->flush();
        return $this->assign($ref,$username, $vinyleRepository);

    }

    /**
     * @Route("/{ref}/{borrower}/assign",name="assign", methods={"GET","POST"} )
     */

    public function assign($ref, $borrower,VinyleRepository $vinyleRepository)
    {
        $result= $vinyleRepository->populate($ref,$borrower);
        return $this->redirectToRoute('borrowing_display');
    }

    /**
     * @Route("/{user}/perso", name="user_perso", methods={"GET","POST"})
     */

    public function perso_user(UserRepository $userRepository)
    {

        if($this->getUser())
        {
            $username = $this->getUser();
            $user = $userRepository->find($username);
        }

        return $this->redirectToRoute('user_edit_customer', array('user' => $user));
    }

    /**
     * @Route("/perso/index", name="perso_index", methods={"GET"})
     */

    public function index_perso(UserRepository $userRepository): Response
    {

        if($this->getUser())
        {
            $userid = $this->getUser()->getId();
        }
        return $this->render('Customer/perso/index.html.twig', ['users' => $userRepository->findByUserId($userid),
        ]);

    }

    /**
     * @Route("/perso/{id}/edit", name="perso_edit_user", methods={"GET","POST"})
     */

    public function perso_edit(Request $request,user $user): Response
    {

        $form = $this->createForm(PersoCustType::class, $user);
        $form->handleRequest($request);
        if ($form->isSubmitted() && $form->isValid())
        {
            $this->getDoctrine()->getManager()->flush();
            return $this->redirectToRoute('perso_index');
        }
        return $this->render('Customer/perso/edit.html.twig', ['user' => $user,'form' => $form->createView(),]);
    }

    /**
     * @Route("/borrowing/display", name="borrowing_display", methods={"GET"})
     */

    public function display_borrowing(BorrowingRepository $borrowingRepository): Response
    {
        if($this->getUser())
        {
        $username = $this->getUser()->getUsername();
        }
        return $this->render('Customer/borrowing/index.html.twig', [
            'borrowings' => $borrowingRepository->BorrowingByBorrower($username),
        ]);
    }

    /**
     * @Route("borrowing/{id}/reception", name="borrowing_reception", methods={"GET","POST"})
     */

    public function reception_borrowing($id)
    {
        $entityManager = $this->getDoctrine()->getManager();
        $borrowing = $entityManager->getRepository(Borrowing::class)->find($id);
	    if (!$borrowing) {
            throw $this->createNotFoundException(
            'No borrowing found for id '.$id
        );
        }

        $borrowing->setBorrowingStatus('Réceptionnée');
        $entityManager->flush();
        return $this->redirectToRoute('borrowing_display', [
        'id' => $borrowing->getId()
        ]);
    }

    /**
     * @Route("/borrowing/{id}/return", name="borrowing_return", methods={"GET","POST"})
     */

    public function return_borrowing(Request $request,borrowing $borrowing): Response
    {

        $form = $this->createForm(Borrowing_ReturnType::class,$borrowing);
        $form->handleRequest($request);
        if ($form->isSubmitted() && $form->isValid())
        {
            $this->getDoctrine()->getManager()->flush();
            return $this->redirectToRoute('borrowing_display');
        }
        return $this->render('Customer/borrowing/return.html.twig', ['borrowing' => $borrowing,'form' => $form->createView()]);
    }

}

templates/Customer/perso/edit.html.twig
{% extends 'base_customer.html.twig' %}

{% block title %}Informations Personnelles{% endblock %}

{% block body %}
	<section id="information-personnel-edit" class="container-fluid">
		<section class="container">
			<header class="row">
                <div class="col-12">
					<h1 class="service">Informations Personnelles</h1>
				</div>
			</header>
			<div class="row">				
					<div class="col-12 bottom">	
						{{ form_start(form) }}
    					{{ form_row(form.genres, { 'label': 'Genre' }) }}
    					{{ form_row(form.firstname, { 'label': 'Prénom' }) }}
						{{ form_row(form.lastname, { 'label': 'Nom' }) }}
						{{ form_row(form.username, { 'label': 'Nom utilsateur' }) }}  
						{{ form_row(form.email, { 'label': 'Email' }) }}
    					{{ form_row(form.phone, { 'label': 'Téléphone' }) }}
    					{{ form_row(form.address, { 'label': 'Adresse' }) }}
    					{{ form_row(form.postal_code, { 'label': 'Code Postal' }) }}
    					{{ form_row(form.city, { 'label': 'Ville' }) }} 
						{{ form_row(form.valider,{'attr':{ 'class':'btn btn-primary envoyer'}}) }}
						{{ form_end(form) }}
    					<a href="{{ path('home') }}">Retour</a>
					</div>
				</div>	
			</div>
		</section>
	</section>				
{% endblock %}

templates/Customer/perso/index.html.twig
{% extends 'base_customer.html.twig' %}
{% block title %}Informations Personelles{% endblock %}
{% block body %}
    <section id="information-personnel-edit" class="container-fluid">
		<section class="container">
			<header class="row">
                <div class="col-12">
                    <h1 class="service">Informations Personelles</h1>
                </div>
            </header>
            <div class="row">
                <div class="col-12">        
                    <table class="table">
                        <tbody>
                        {% for user in users %}
			                <tr>
                                <th class="table-head">Genre</th>
                                <td>{{ user.genres }}</td>
			                </tr>
			                <tr>
                                <th class="table-head" >Prénom</th>
                                <td>{{ user.firstname }}</td>
                            </tr>
			                <tr>
                                <th class="table-head">Nom</th>                                             
                                <td>{{ user.lastname }}</td>
                            </tr>
                             <tr>
                                <th class="table-head">Nom d'utilisateur</th>                                             
                                <td>{{ user.username }}</td>
                            </tr>
                            <tr>
                                <th class="table-head">Email</th>  
                                <td>{{ user.email }}</td>
			                </tr>
			                <tr>
                                <th class="table-head">Adresse</th>
                                <td>{{ user.address }}</td>
                            </tr>
			                <tr>
                                <th class="table-head">Téléphone</th>
                                <td>{{ user.phone }}</td>
                            </tr>
			                <tr>
                                <th class="table-head">Code Postal</th>
                                <td>{{ user.postalCode }}</td>
                            </tr>
                            <tr>
                                <th class="table-head">Ville</th>
                                <td>{{ user.city }}</td>
                            </tr>
                            <tr>
                                <th class="table-head">Abonnement</th>
                                <td>{{ user.subscription }}</td>
                            </tr>
                            <tr>
                                <th class="table-head">Statut de l'abonnement</th>
                                <td>{{ user.subscriptionstatus }}</td>
                            </tr>
                            <tr>
                                <td colspan = "2">
                                    <a href="{{ path('perso_edit_user', {'id': user.id}) }}">Modifier mes Infos Personnelles</a>
                                </td>
                            </tr>
                            {% else %}
                            <tr>
                                <td colspan="15">pas d'enregistrement</td>
                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </section>
    </section>        
{% endblock %}
{% block javascripts %}
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
{% endblock %}  